function RoleplayData.GiveMoney(userid, strText)
	local Name = _PlayerInfo(userid, "name") -- Find the name of the player
	NoNameTxt1 = string.gsub( Name, "([%[%]%(%)%%%+%-%*%?%^%$%.])", "%%%1" ) -- Lets get rid of the special chars.
	NoNameTxt = string.gsub(strText, NoNameTxt1..":", "") -- Remove the name

	Text = _Explode(NoNameTxt, " ", 3)
	if string.lower(Text[2]) == string.lower("/give") then -- Check if the player typed "/give"
	local Amount = math.round(tonumber(Text[3]), 0.01)
		if Amount == nil then 
		_PrintMessage(userid, 3, "That is not a valid number!")
		return true
		elseif Amount < 0 then
		_PrintMessage(userid, 3, "You can't give away a negative amount!")
		return true
		elseif Amount == 0 then
		_PrintMessage(userid, 3, "You can't give away nothing!")
		return true
		end
		if (RoleplayData[userid].Cash - Amount) >= 0 then
		_TraceLine(_PlayerGetShootPos(userid), _PlayerGetShootAng(userid), RoleplayData.UseRange, userid)
			if _EntGetType(_TraceGetEnt()) == "player" then
			local Reciever = _PlayerInfo(_TraceGetEnt(), "name")
			_PrintMessage(userid, 3, "You gave " .. RoleplayData.CashPrefix .. Amount .. " to " .. Reciever .. ".")
			_PrintMessage(userid, 1, "You gave " .. RoleplayData.CashPrefix .. Amount .. " to " .. Reciever .. ".")
			RoleplayData.TakeMoney(userid, Amount)
			RoleplayData.ShowGUI(userid)
			_PrintMessage(_TraceGetEnt(), 3, "You recieved " .. RoleplayData.CashPrefix .. Amount .. " from " .. Name .. ".")
			_PrintMessage(_TraceGetEnt(), 1, "You recieved " .. RoleplayData.CashPrefix .. Amount .. " from " .. Name .. ".")
			RoleplayData.AddMoney(_TraceGetEnt(), Amount)
			RoleplayData.ShowGUI(_TraceGetEnt())
			else
			_PrintMessage(userid, 3, "You have to look at a player!")
			end
		else
		_PrintMessage(userid, 3, "You don't have enough money!")
		end
		return true
	elseif string.lower(Text[2]) == string.lower("/drop") then
		if RoleplayData[userid].IsSleeping then
		_PrintMessage(userid, 3, "You can't drop money while sleeping!")
		return true
		end
		local Amount = math.round(tonumber(Text[3]), 0.01)
		if Amount == nil then 
		_PrintMessage(userid, 3, "That is not a valid number!")
		return true
		elseif Amount < 0 then
		_PrintMessage(userid, 3, "You can't drop a negative amount!")
		return true
		elseif Amount == 0 then
		_PrintMessage(userid, 3, "You can't drop nothing!")
		return true
		end
		if (RoleplayData[userid].Cash - Amount) >= 0 then
		_TraceLine(_PlayerGetShootPos(userid), _PlayerGetShootAng(userid), 50, userid)
		local Money = _EntCreate("prop_physics")
		_EntPrecacheModel("models/props_junk/garbage_bag001a.mdl")
		_EntSetModel(Money, "models/props_junk/garbage_bag001a.mdl")
		_EntSetPos(Money, _TraceEndPos())
		_EntSpawn(Money)
		
		local MoneyInfo = {}
		MoneyInfo.MoneyID = Money
		MoneyInfo.Amount = Amount
		table.insert(RoleplayData.Money, MoneyInfo)
		RoleplayData.TakeMoney(userid, Amount)
		RoleplayData.ShowGUI(userid)
		else
		_PrintMessage(userid, 3, "You don't have enough money!")
		end
	return true
	end
end 

function RoleplayData.ShowMoneyInfo(userid)
	_TraceLine(_PlayerGetShootPos(userid), _PlayerGetShootAng(userid), 150, userid)
	if _TraceHitNonWorld() then	
	local Ent = _TraceGetEnt()
		for i in RoleplayData.Money do
			if Ent == RoleplayData.Money[i].MoneyID then
			RoleplayData.MoneyBagText(Ent, RoleplayData.Money[i].Amount, userid)
			end
		end
	end
end

function RoleplayData.MoneyBagText(ent, amount, userid)
	--if not RoleplayData.ShowMoneyText then return end
	_GModText_Start("CloseCaption_Bold")
	_GModText_SetColor(0, 150, 0, 255)
	_GModText_SetEntity(ent)
	_GModText_SetEntityOffset(vector3(0,0,10))
	_GModText_SetText(RoleplayData.CashPrefix .. amount)
	_GModText_SetTime(3, 0.1, 0.5)
	_GModText_Send(userid, (RoleplayData.IndexGUI + 2000))
end

function RoleplayData.TakeMoneyBag(userid, entity)
	for i in RoleplayData.Money do
		if entity == RoleplayData.Money[i].MoneyID then
		RoleplayData.AddMoney(userid, RoleplayData.Money[i].Amount)
		table.remove(RoleplayData.Money, i)
		_EntRemove(entity)
		RoleplayData.ShowGUI(userid)
		end
	end
end
